> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/tools-terraform/docs/data-sources/servers.md).

# ionoscloud\_servers

Retrieves a list of IONOS CLOUD Servers

The **Servers data source** can be used to search for and return existing servers based on filters used.

## Example Usage

### By Name

```hcl
data ionoscloud_servers example {
  datacenter_id = ionoscloud_datacenter.example.id
  filter {
    name = "name"
    value = "server_name_to_look_here"
  }
}
```

### By CPU Family

```hcl
data ionoscloud_servers example {
  datacenter_id = ionoscloud_datacenter.example.id
  filter {
    name = "cpu_family"
    value = "INTEL_XEON"
  }
}
```

### By Name and Cores

```hcl
data ionoscloud_servers example {
  datacenter_id = ionoscloud_datacenter.example.id
  filter {
    name = "name"
    value = "test"
  }
  filter {
    name = "cores"
    value = "1"
  }
}
```

## Argument Reference

* `datacenter_id` - (Required) Name of an existing datacenter that the servers are a part of
* `filter` - (Optional) One or more name/value pairs to filter off of. You can use most base fields in the [server](/cloud/tools-terraform/docs/resources/server.md) resource. These do **NOT** include nested fields in nics or volume nested fields.

`datacenter_id` must be provided. If `datacenter_id` is missing , the datasource will return an error.

**NOTE:** Lookup by filter is partial. Searching for a server using filter name and value `test`, will find all servers that have `test` in the name. For example, it will find servers named `test`, `test1`, `testsomething`.

**NOTE:** You cannot search by `image_name` by providing an alias like `ubuntu`.

## Attributes Reference

The following attributes are returned by the datasource:

* `servers` - list of servers that matches the filters provided. For a full reference of all attributes returned, check out [documentation](/cloud/tools-terraform/docs/resources/server.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/tools-terraform/docs/data-sources/servers.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
